package auth

import (
	"encoding/json"
	"fmt"
	"git.168cad.top/go/wechat/httpclient"
	"git.168cad.top/go/wechat/miniprogram/auth/response"
)

type Client struct {

}

func NewClient() *Client {
	return &Client{}
}

// Code2Session 登录凭证校验。
// https://developers.weixin.qq.com/miniprogram/dev/api-backend/open-api/login/auth.code2Session.html
func (comp *Client) Code2Session(code string, appId string, secret string) (*response.ResponseCode2Session, error) {
	result := &response.ResponseCode2Session{}
	var url = fmt.Sprintf("https://api.weixin.qq.com/sns/jscode2session?appid=%s&secret=%s&js_code=%s&grant_type=authorization_code", appId, secret, code)
	r,err := httpclient.Get(url)
	if err != nil{
		return nil, err
	}
	e := json.Unmarshal(r, result)
	if err != nil{
		return nil, e
	}
	return result, nil
}
